//+------------------------------------------------------------------+
//Market Sessions Indicator GPL
//+------------------------------------------------------------------+

#property indicator_chart_window

//--------------------------------------
extern int    NumberOfDays = 500;        // 
extern string AsiaBegin    = "03:00";   // 
extern string AsiaEnd      = "12:00";   // 
extern color  AsiaColor=MidnightBlue; // 
extern bool   AsiaExtend   = false; // 
extern string EurBegin     = "10:00";   // 
extern string EurEnd       = "19:00";   // 
extern color  EurColor= DarkKhaki;       // 
extern bool   EurExtend   = false; // 
extern string USABegin     = "15:00";   // 
extern string USAEnd       = "00:00";   // 
extern color  USAColor=DarkBlue; // 
extern bool   USAExtend   = true; // 
extern bool   GapCorrection   = true; // 
extern long   GapTimeSpan   = 262800; // Corresponds to 3 days and 1 hour
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() 
  {
   DeleteObjects();
   for(int i=0; i<NumberOfDays; i++) 
     {
      CreateObjects("ASw"+i,AsiaColor);
      CreateObjects("EUw"+i,EurColor);
      CreateObjects("USw"+i,USAColor);
      CreateObjects("ASv"+i,AsiaColor);
      CreateObjects("EUv"+i,EurColor);
      CreateObjects("USv"+i,USAColor);
     }
   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() 
  {
   DeleteObjects();
   Comment("");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateObjects(string no,color cl) 
  {
   ObjectCreate(no,OBJ_TREND,0,0,0,0,0);
   ObjectSet(no,OBJPROP_STYLE,STYLE_DOT);
   ObjectSet(no,OBJPROP_COLOR,cl);
   ObjectSet(no,OBJPROP_BACK,True);
   ObjectSet(no,OBJPROP_WIDTH,1);
   ObjectSet(no,OBJPROP_RAY_RIGHT,false);
   ObjectSet(no,OBJPROP_HIDDEN,false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteObjects() 
  {
   for(int i=0; i<NumberOfDays; i++) 
     {
      ObjectDelete("ASw"+i);
      ObjectDelete("EUw"+i);
      ObjectDelete("USw"+i);
      ObjectDelete("ASv"+i);
      ObjectDelete("EUv"+i);
      ObjectDelete("USv"+i);
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() 
  {
   datetime dt=CurTime();
   int weekday=TimeDayOfWeek(dt);
   for(int i=0; i<NumberOfDays; i++) 
     {
      while(weekday==0) { dt=decDateTradeDay(dt); 
         weekday=TimeDayOfWeek(dt);
         }
      if (weekday==1) {
      if (!AsiaExtend) DrawObjects(dt,"ASw"+i,AsiaBegin,AsiaEnd);
      if (!EurExtend) DrawObjects(dt,"EUw"+i,EurBegin,EurEnd);
      if (!USAExtend) DrawObjects(dt,"USw"+i,USABegin,USAEnd);
      if (!AsiaExtend) DrawObjects(dt,"ASv"+i,AsiaBegin,AsiaEnd);
      if (!EurExtend) DrawObjects(dt,"EUv"+i,EurBegin,EurEnd);
      if (!USAExtend) DrawObjects(dt,"USv"+i,USABegin,USAEnd);   
     
      }
      if (weekday>1 && weekday<6) {
      DrawObjects(dt,"ASw"+i,AsiaBegin,AsiaEnd);
      DrawObjects(dt,"EUw"+i,EurBegin,EurEnd);
      DrawObjects(dt,"USw"+i,USABegin,USAEnd);
      DrawObjects(dt,"ASv"+i,AsiaBegin,AsiaEnd);
      DrawObjects(dt,"EUv"+i,EurBegin,EurEnd);
      DrawObjects(dt,"USv"+i,USABegin,USAEnd);
 
      }
      if (weekday==6) {
      if (AsiaExtend) DrawObjects(dt,"ASw"+i,AsiaBegin,AsiaEnd);
      if (EurExtend) DrawObjects(dt,"EUw"+i,EurBegin,EurEnd);
      if (USAExtend) DrawObjects(dt,"USw"+i,USABegin,USAEnd); 
      if (AsiaExtend) DrawObjects(dt,"ASv"+i,AsiaBegin,AsiaEnd);
      if (EurExtend) DrawObjects(dt,"EUv"+i,EurBegin,EurEnd);
      if (USAExtend) DrawObjects(dt,"USv"+i,USABegin,USAEnd);
     
      
      }
      dt=decDateTradeDay(dt);
      weekday=TimeDayOfWeek(dt);
         
            
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt,string no,string tb,string te) 
  {
   datetime t1,t2,t3,t4;
   double   p1,p2;
   int      b1,b2;
   long     d1;
      
   if(StringFind(no,"US",0)==0 && USAExtend ) {t1=ExtendDate(dt,tb);}
   else if (StringFind(no,"EU",0)==0 && EurExtend ) {t1=ExtendDate(dt,tb);}
   else if (StringFind(no,"AS",0)==0 && AsiaExtend ) {t1=ExtendDate(dt,tb);}
   else {
      t1=StrToTime(TimeToStr(dt,TIME_DATE)+" "+tb);
     }
   t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
   b1=iBarShift(NULL, 0, t1);
   b2=iBarShift(NULL, 0, t2);
   t3=iTime(NULL, 0, b1);
   t4=iTime(NULL, 0, b2);
   
   if (GapCorrection && GapTimeSpan>0) { 
      d1=t4-t3;
      if ( d1>0 && d1>=GapTimeSpan) { return; }
   }
   p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2+1, b2)];
   p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2+1, b2)];
      if(StringFind(no,"w",0)==2) {
      ObjectSet(no,OBJPROP_TIME1,t3);
      ObjectSet(no,OBJPROP_PRICE1,p1);
      ObjectSet(no,OBJPROP_TIME2,t4);
      ObjectSet(no,OBJPROP_PRICE2,p1); 
      }
      else if(StringFind(no,"v",0)==2) {
      ObjectSet(no,OBJPROP_TIME1,t3);
      ObjectSet(no,OBJPROP_PRICE1,p2);
      ObjectSet(no,OBJPROP_TIME2,t4);
      ObjectSet(no,OBJPROP_PRICE2,p2); 
      }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime decDateTradeDay(datetime dt) 
  {
   int ty=TimeYear(dt);
   int tm=TimeMonth(dt);
   int td=TimeDay(dt);
   int th=TimeHour(dt);
   int ti=TimeMinute(dt);

   td--;
   if(td==0) 
     {
      tm--;
      if(tm==0) 
        {
         ty--;
         tm=12;
        }
      if(tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
      if(tm==2) if(MathMod(ty, 4)==0) td=29; else td=28;
      if(tm==4 || tm==6 || tm==9 || tm==11) td=30;
     }
   return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime ExtendDate(datetime dt,string tb) 
  {
   int ty=TimeYear(dt);
   int tm=TimeMonth(dt);
   int td=TimeDay(dt);
   int th=TimeHour(dt);
   int ti=TimeMinute(dt);

   td--;
   if(td==0) 
     {
      tm--;
      if(tm==0) 
        {
         ty--;
         tm=12;
        }
      if(tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
      if(tm==2) if(MathMod(ty, 4)==0) td=29; else td=28;
      if(tm==4 || tm==6 || tm==9 || tm==11) td=30;
     }
   return(StrToTime(ty+"."+tm+"."+td+" "+tb));
  }
//+------------------------------------------------------------------+
